/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_TRAD                                                     */
/* Tabela : PROPRIED                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 04/11/2005 - THALES HENRIQUE       		      */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TRAD
BEFORE INSERT OR UPDATE OR DELETE
ON PROPRIED FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTRAD := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.STVALORPROP,0) <> NVL(:NEW.STVALORPROP,0)) THEN
         :NEW.DTULTATUTRAD := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PROPRIED', '','IDIDIOMA='||:OLD.IDIDIOMA||';CDPROGTRAD='||:OLD.CDPROGTRAD||';NMFORMULARIO='||:OLD.NMFORMULARIO||';NMCOMPONENTE='||:OLD.NMCOMPONENTE||';NMPROPRIED='||:OLD.NMPROPRIED||';NRVALORPROP='||:OLD.NRVALORPROP||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PROPRIED MODIFY DTULTATUTRAD DEFAULT SYSDATE
/
