
IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'IMPOSTOORCA_RELGESDIRETA' AND
              TYPE = 'P' 		   AND
              U.UID = O.UID                AND
              U.NAME = USER)

DROP PROCEDURE IMPOSTOORCA_RELGESDIRETA
GO


CREATE  PROCEDURE IMPOSTOORCA_RELGESDIRETA  @P_CDFILIAL        VARCHAR(04),
                                            @P_NRANOORCAOP     VARCHAR(10),
                                            @P_NRITLANCROP     VARCHAR(10),
                                            @P_CDSERVFILIAPGD  VARCHAR(05)

AS
   DECLARE @V_IDENDCFOP         VARCHAR(01);
   DECLARE @V_CDGRUPOFISC       VARCHAR(03);
   DECLARE @V_TIPOOPER          VARCHAR(02);
   DECLARE @V_CDEMPRESA         VARCHAR(02);
   DECLARE @V_CDINSCESTA        VARCHAR(16);
   DECLARE @V_PAISORIG          VARCHAR(04);
   DECLARE @V_ESTAORIG          VARCHAR(02);
   DECLARE @V_MUNIORIG          VARCHAR(04);
   DECLARE @V_PAISDEST          VARCHAR(04);
   DECLARE @V_ESTADEST          VARCHAR(02);
   DECLARE @V_MUNIDEST          VARCHAR(04);
   DECLARE @V_NRALIQTEMP        VARCHAR(14);
   DECLARE @V_NRLANCTONF        VARCHAR(20);
   DECLARE @V_IDENDEMIS         VARCHAR(01);
   DECLARE @V_IDTRIMPSTII       VARCHAR(01);
   DECLARE @V_PARDEDTMP         DOUBLE PRECISION;
   DECLARE @V_PREDBCTMP         DOUBLE PRECISION;
   DECLARE @V_ALIQUTMP          DOUBLE PRECISION;
   DECLARE @V_TRATIMPST         VARCHAR(01);
   DECLARE @V_PBCSUBTRIB        DOUBLE PRECISION;
   DECLARE @V_IDPMCBASECAL      VARCHAR(01);
   DECLARE @V_CDIMPOSTRIB       VARCHAR(02);
   DECLARE @V_IDVRIMPSTRIB      VARCHAR(01);
   DECLARE @V_VRMAXVENDA        DOUBLE PRECISION;
   DECLARE @V_VRPEMAXVENDA      DOUBLE PRECISION;
   DECLARE @V_TAXABASECALC      DOUBLE PRECISION;
   DECLARE @V_TAXAALIQUOTA      DOUBLE PRECISION;
   DECLARE @V_TAXABCSUBSTR      DOUBLE PRECISION;
   DECLARE @V_BASECALCIT        DOUBLE PRECISION;
   DECLARE @V_PERDBCALC         DOUBLE PRECISION;
   DECLARE @V_IMPOSTOIT         DOUBLE PRECISION;
   DECLARE @V_BASECALCTO        DOUBLE PRECISION;
   DECLARE @V_BASEVLRMAX        DOUBLE PRECISION;
   DECLARE @V_CALCVLRMAX        DOUBLE PRECISION;
   DECLARE @V_IMPOSTOTAL        DOUBLE PRECISION;
   DECLARE @V_NRSEQRELACIT      VARCHAR(10);
   DECLARE @V_TEXT              VARCHAR(50);
   DECLARE @V_CDFILIALAPGD      VARCHAR(04);
   DECLARE @V_CDCLIENTEAPGD     VARCHAR(21);
   DECLARE @V_CDSERVFILIAPGD    VARCHAR(05);

   DECLARE @V_DTAPURACFATGD     DATETIME;
   DECLARE @V_NRAPURACGD        VARCHAR(10);
   DECLARE @V_CDPRODUTOAPGD     VARCHAR(20);
   DECLARE @V_NREFETIVOSAPGD    VARCHAR(10);
   DECLARE @V_VRPRECUNITAPGD    DOUBLE PRECISION;
   DECLARE @V_VRFATUR           DOUBLE PRECISION;
   DECLARE @V_CDIMPOTEMP        VARCHAR(10);
   DECLARE @V_CDFISCTEMP        VARCHAR(10);
   DECLARE @V_IDTRATIMPTMP      VARCHAR(10);
   DECLARE @V_IDUTMUNIORIG      VARCHAR(10);
   DECLARE @V_IDCONSISTENT      VARCHAR(10);
   DECLARE @V_IDIMPORECUP       VARCHAR(10);
   DECLARE @V_IDTRATIMPO        VARCHAR(10);
   DECLARE @V_IDUTPADRROP       VARCHAR(1);
   DECLARE @V_IDUTPADRROPFIL    VARCHAR(1);
   DECLARE @V_CDFILCENTPME      VARCHAR(4);
   DECLARE @V_IDFILIALAGRROP    VARCHAR(1);
   DECLARE @V_FILIALPAR         VARCHAR(4);
   DECLARE @V_CDCLIENTE         VARCHAR(20);
   DECLARE @V_IDCLIENPRIN       VARCHAR(2);

   DECLARE @V_VRBASECALEFET     DOUBLE PRECISION;
   DECLARE @V_QTBASECALEFET     DOUBLE PRECISION;

   DECLARE @V_NRMES           INTEGER;
   DECLARE @V_COUNT           INTEGER;

   DECLARE @V_TESTE VARCHAR(100);

   DECLARE @V_CDFILIAL          VARCHAR(04);
   DECLARE @V_CDSERVFILI        VARCHAR(05);
   DECLARE @V_CDARVPROD         VARCHAR(20);
   DECLARE @V_CDPRODUTO         VARCHAR(10);
   DECLARE @V_VRORCAMENTOJAN    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOFEV    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOMAR    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOABR    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOMAI    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOJUN    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOJUL    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOAGO    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOSET    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTOOUT    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTONOV    DOUBLE PRECISION;
   DECLARE @V_VRORCAMENTODEZ    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOJAN    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOFEV    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOMAR    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOABR    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOMAI    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOJUN    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOJUL    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOAGO    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOSET    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTOOUT    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTONOV    DOUBLE PRECISION;
   DECLARE @V_QTORCAMENTODEZ    DOUBLE PRECISION;
   DECLARE @V_DTMESBASEITEM     DATETIME;
   DECLARE @V_IDINTEREST        VARCHAR(1);
   DECLARE @V_NRINSCSUFRAMA     VARCHAR(09);
BEGIN

   SET @V_TIPOOPER      = '01';
   SET @V_NRSEQRELACIT  = '0';

   SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFIL),'I'),
        @V_CDEMPRESA = MAX(CDEMPRESA),
        @V_CDINSCESTA = MAX(CDINSCESTA)
   FROM FILIAL
   WHERE CDFILIAL = @P_CDFILIAL;

   SELECT @V_IDUTPADRROP = IDUTPADRROP
   FROM PARAMGERAL G;

   SELECT @V_IDUTPADRROPFIL = IDUTPADRROPFIL,
          @V_CDFILCENTPME   = CDFILCENTPME
   FROM FILIAL F LEFT JOIN PARFILIALROP P ON
                     P.CDFILIAL = F.CDFILIAL
   WHERE
      F.CDFILIAL  = @P_CDFILIAL;

   IF (@V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S') BEGIN
      SET @V_FILIALPAR = 'P';
   END
   ELSE BEGIN
      IF @V_CDFILCENTPME IS NULL BEGIN
         SET @V_FILIALPAR = @P_CDFILIAL;
      END
      ELSE BEGIN
         SELECT @V_IDFILIALAGRROP = ISNULL(MAX(IDFILIALAGRROP),'N')
         FROM PARFILIALROP
         WHERE CDFILIAL = @V_CDFILCENTPME;

         IF @V_IDFILIALAGRROP = 'S' BEGIN
            SET @V_FILIALPAR = @V_CDFILCENTPME;
         END
         ELSE BEGIN
            SET @V_FILIALPAR = @P_CDFILIAL;
         END;
      END;
   END;

   SET @V_TEXT = 'LANCNF/FILIAL'+@P_CDFILIAL;

   EXEC TEKNISA.NOVO_CODIGO_SC @V_TEXT, @P_SEQUENCIAL = @V_NRLANCTONF OUTPUT, @P_QTDE = 1;

   SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 10, 10);

   DECLARE  C_FATURA CURSOR FOR
      SELECT T.CDFILIAL, T.CDSERVFILI, P.CDARVPROD,  P.CDPRODUTO, VRORCAMENTOJAN, VRORCAMENTOFEV, VRORCAMENTOMAR,
             VRORCAMENTOABR, VRORCAMENTOMAI, VRORCAMENTOJUN, VRORCAMENTOJUL, VRORCAMENTOAGO, VRORCAMENTOSET,
             VRORCAMENTOOUT, VRORCAMENTONOV, VRORCAMENTODEZ , QTORCAMENTOJAN, QTORCAMENTOFEV,  QTORCAMENTOMAR,
             QTORCAMENTOABR,  QTORCAMENTOMAI,  QTORCAMENTOJUN,  QTORCAMENTOJUL, QTORCAMENTOAGO,  QTORCAMENTOSET,
             QTORCAMENTOOUT,  QTORCAMENTONOV,  QTORCAMENTODEZ, DTMESBASEITEM
      FROM ITEMORCAOP T, PRODUTO P, SERVICO S
      WHERE T.CDFILIAL = @P_CDFILIAL
        AND NRANOORCAOP = @P_NRANOORCAOP
        AND IDTIPOORCAOP = 'F'
        AND T.CDSERVFILI = S.CDSERVFILI
        AND T.CDFILIAL = S.CDFILIAL
        AND T.CDSERVFILI = @P_CDSERVFILIAPGD
        AND S.CDPRODUTO = P.CDPRODUTO

   OPEN C_FATURA;
   FETCH NEXT FROM C_FATURA INTO @V_CDFILIAL, @V_CDSERVFILI, @V_CDARVPROD,  @V_CDPRODUTO, @V_VRORCAMENTOJAN, @V_VRORCAMENTOFEV,
               @V_VRORCAMENTOMAR, @V_VRORCAMENTOABR, @V_VRORCAMENTOMAI, @V_VRORCAMENTOJUN, @V_VRORCAMENTOJUL, @V_VRORCAMENTOAGO,
               @V_VRORCAMENTOSET, @V_VRORCAMENTOOUT, @V_VRORCAMENTONOV, @V_VRORCAMENTODEZ , @V_QTORCAMENTOJAN, @V_QTORCAMENTOFEV,
               @V_QTORCAMENTOMAR, @V_QTORCAMENTOABR,  @V_QTORCAMENTOMAI,  @V_QTORCAMENTOJUN,  @V_QTORCAMENTOJUL, @V_QTORCAMENTOAGO,
               @V_QTORCAMENTOSET, @V_QTORCAMENTOOUT,  @V_QTORCAMENTONOV,  @V_QTORCAMENTODEZ, @V_DTMESBASEITEM;

   WHILE (@@FETCH_STATUS = 0)   BEGIN

      IF @V_IDENDCFOP = 'I' BEGIN

         SELECT @V_PAISORIG = MAX(CDPAIS),
                @V_ESTAORIG = MAX(SGESTADO),
                @V_MUNIORIG = MAX(CDMUNICIPIO)
         FROM INSCRESTAD
         WHERE CDEMPRESA  = @V_CDEMPRESA
           AND CDINSCESTA = @V_CDINSCESTA;
      END
      ELSE BEGIN

         SELECT @V_PAISORIG = MAX(CDPAIS),
                @V_ESTAORIG = MAX(SGESTADO),
                @V_MUNIORIG = MAX(CDMUNICIPIO)
         FROM ENDEFILI
         WHERE (CDFILIAL     = @V_CDFILIAL)
           AND (IDTPENDEFILI = @V_IDENDCFOP);
      END;

      SET @V_IDINTEREST = 'N';
      IF (@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG) BEGIN
         SET @V_IDINTEREST = 'S';
      END;

      EXEC TEKNISA.CONSULTA_INCIDENCIA 'S', @V_CDEMPRESA, @V_CDARVPROD, @V_CDINSCESTA, @V_TIPOOPER, @P_CDFILIAL, @V_NRLANCTONF, null, NULL, @V_IDINTEREST;

      SET @V_IMPOSTOTAL = 0;

      DECLARE C_INCIDENCIA CURSOR FOR
         SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                IDCONSISTENT, IDIMPORECUP, IP.IDTRATIMPO
         FROM INCITEMP IT, IMPOSTO IP, IMPOSTOROP IR
         WHERE (IT.NRINCITEMP = @P_CDFILIAL+@V_NRLANCTONF) AND
               (IP.CDIMPOSTO  = IT.CDIMPOTEMP)             AND
               (IP.IDPRODNOTA = 'P')                       AND
               (IR.CDFILIAL   = @V_FILIALPAR)              AND
               (CDIMPOTEMP    = IR.CDIMPOSTO)              AND
               (IDTPIMPOSTOROP IN ('FE', 'AB'))
         ORDER BY CDIMPOTEMP;

      OPEN C_INCIDENCIA;
      FETCH NEXT FROM C_INCIDENCIA INTO @V_CDIMPOTEMP,   @V_CDFISCTEMP,   @V_IDTRATIMPTMP,
                                        @V_IDUTMUNIORIG, @V_IDCONSISTENT, @V_IDIMPORECUP,
                                        @V_IDTRATIMPO;

      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SELECT
            @V_CDCLIENTE = MAX(A.CDCLIENTE),
            @V_IDCLIENPRIN = MAX(A.IDCLIENPRIN),
            @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI), 'P')
         FROM
            CLIENFILIAL A, CLIENTE C
         WHERE A.CDFILIAL = @P_CDFILIAL
           AND A.IDCLIENPRIN = 'S'
           AND A.CDCLIENTE = C.CDCLIENTE;

         SELECT
          @V_PAISDEST =  MAX(CDPAIS),
          @V_ESTADEST =  MAX(SGESTADO),
          @V_MUNIDEST =  MAX(CDMUNICIPIO)
         FROM ENDECLIE
         WHERE (CDCLIENTE    = @V_CDCLIENTE) AND
               (IDTPENDECLIE = @V_IDENDEMIS);

         SET @V_NRMES = 1;

         SET @V_NRSEQRELACIT = @V_NRSEQRELACIT + 1;

         WHILE  (@V_NRMES <= 12) BEGIN

            SET @V_VRBASECALEFET = CASE @V_NRMES
                                    WHEN 1 THEN @V_VRORCAMENTOJAN
                                    WHEN 2 THEN @V_VRORCAMENTOFEV
                                    WHEN 3 THEN @V_VRORCAMENTOMAR
                                    WHEN 4 THEN @V_VRORCAMENTOABR
                                    WHEN 5 THEN @V_VRORCAMENTOMAI
                                    WHEN 6 THEN @V_VRORCAMENTOJUN
                                    WHEN 7 THEN @V_VRORCAMENTOJUL
                                    WHEN 8 THEN @V_VRORCAMENTOAGO
                                    WHEN 9 THEN @V_VRORCAMENTOSET
                                    WHEN 10 THEN @V_VRORCAMENTOOUT
                                    WHEN 11 THEN @V_VRORCAMENTONOV
                                    ELSE  @V_VRORCAMENTODEZ END;


            SET @V_QTBASECALEFET = CASE @V_NRMES
                                    WHEN 1 THEN @V_QTORCAMENTOJAN
                                    WHEN 2 THEN @V_QTORCAMENTOFEV
                                    WHEN 3 THEN @V_QTORCAMENTOMAR
                                    WHEN 4 THEN @V_QTORCAMENTOABR
                                    WHEN 5 THEN @V_QTORCAMENTOMAI
                                    WHEN 6 THEN @V_QTORCAMENTOJUN
                                    WHEN 7 THEN @V_QTORCAMENTOJUL
                                    WHEN 8 THEN @V_QTORCAMENTOAGO
                                    WHEN 9 THEN @V_QTORCAMENTOSET
                                    WHEN 10 THEN @V_QTORCAMENTOOUT
                                    WHEN 11 THEN @V_QTORCAMENTONOV
                                    ELSE  @V_QTORCAMENTODEZ  END;

            SET @V_DTAPURACFATGD = CONVERT(DATETIME,CONVERT(VARCHAR,DAY(DATEADD(MM, 1, @V_DTMESBASEITEM) - DAY(DATEADD(MM, 1, @V_DTMESBASEITEM))))+'/'+CONVERT(VARCHAR,MONTH(@V_DTMESBASEITEM))+'/'+CONVERT(VARCHAR,YEAR(@V_DTMESBASEITEM)));

            IF @V_IDUTMUNIORIG = 'D' BEGIN

               /* CONSIDERA O MUNICIPIO DE DESTINO */
               EXEC TEKNISA.CONSULTA_ALIQUOTA @V_CDIMPOTEMP, 'S', @V_CDEMPRESA, @V_CDARVPROD, @V_CDINSCESTA, @V_PAISORIG,
                                      @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_VRBASECALEFET , @V_DTAPURACFATGD,
                                      @P_CDFILIAL, @V_NRLANCTONF, NULL, @V_TIPOOPER;
            END
            ELSE BEGIN
              /* CONSIDERA O MUNICIPIO DE ORIGEM */
               EXEC TEKNISA.CONSULTA_ALIQUOTA @V_CDIMPOTEMP, 'S', @V_CDEMPRESA, @V_CDARVPROD, @V_CDINSCESTA, @V_PAISORIG,
                                      @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRBASECALEFET , @V_DTAPURACFATGD,
                                      @P_CDFILIAL, @V_NRLANCTONF, NULL, @V_TIPOOPER;
            END;

            SET @V_NRALIQTEMP = 0;
            SET @V_PARDEDTMP  = 0;
            SET @V_PREDBCTMP  = 0;
            SET @V_ALIQUTMP   = 0;
            SET @V_IMPOSTOIT  = 0;

            SELECT @V_NRALIQTEMP   = ISNULL(MAX(NRALIQTEMP),0),
                   @V_PARDEDTMP    = ISNULL(MAX(VRPARDEDTMP),0),
                   @V_PREDBCTMP    = ISNULL(MAX(VRPREDBCTMP),0),
                   @V_ALIQUTMP     = ISNULL(MAX(VRALIQUTMP),0),
                   @V_TRATIMPST    = ISNULL(MAX(IDTRIMPSTTMP), '0'),
                   @V_PBCSUBTRIB   = ISNULL(MAX(VRPBCSTTMP),0),
                   @V_IDPMCBASECAL = ISNULL(MAX(IDPMCBSCALTMP), 'S')
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAL+@V_NRLANCTONF);

            SELECT @V_CDIMPOSTRIB  = MAX(CDIMPOSTO),
                   @V_IDVRIMPSTRIB = MAX(IDVRIMPSTRIB)
            FROM IMPOSTO
            WHERE CDIMPOSTRIB = @V_CDIMPOTEMP;

            SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
            SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
            SET @V_TAXABCSUBSTR = 1 + (@V_PBCSUBTRIB/100);


            SET @V_BASECALCIT   = @V_VRBASECALEFET * @V_TAXABASECALC;

            SET @V_PERDBCALC    = 100 - @V_PREDBCTMP;


            IF @V_PBCSUBTRIB > 0 BEGIN
               SET @V_BASECALCIT = (@V_BASECALCIT * @V_TAXABCSUBSTR);
               SET @V_PREDBCTMP  = @V_PBCSUBTRIB;
               SET @V_PERDBCALC  = 0;
            END;

            SET @V_BASEVLRMAX   = 0;
            SET @V_VRPEMAXVENDA = 0;
            SET @V_VRMAXVENDA   = 0;
            SET @V_CALCVLRMAX   = 0;

            SELECT @V_NRINSCSUFRAMA = MAX(NRINSCSUFRAMACL) /*Verifica se h Inscrio Suframa cadastrado p o Cliente*/
              FROM CLIENTE
             WHERE (CDCLIENTE = @V_CDCLIENTE);

            IF @V_NRINSCSUFRAMA IS NULL BEGIN
               SELECT @V_VRMAXVENDA   = ISNULL(MAX(VRMAXVENDA),0),
                      @V_VRPEMAXVENDA = ISNULL(MAX(VRPEMAXVENDA),0)
                 FROM VRMAXVENPROD A
                WHERE (CDPAIS      = @V_PAISDEST) AND
                      (SGESTADO    = @V_ESTADEST) AND
                      (A.CDPRODUTO = @V_CDPRODUTOAPGD);
            END
            ELSE BEGIN
               SELECT @V_VRMAXVENDA   = ISNULL(MAX(VRMAXVENDA),0),
                      @V_VRPEMAXVENDA = ISNULL(MAX(VRPEMAXVENDA),0)
                 FROM VRMAXVENPROD A
                WHERE (CDPAIS      = '0055') AND
                      (SGESTADO    = 'SF'  ) AND
                      (A.CDPRODUTO = @V_CDPRODUTOAPGD);
            END;

            IF @V_VRMAXVENDA IS NOT NULL BEGIN
               SET @V_CALCVLRMAX = (@V_QTBASECALEFET * @V_VRMAXVENDA) * (@V_VRPEMAXVENDA/100);
               SET @V_BASEVLRMAX = @V_CALCVLRMAX;
            END;

            IF @V_CDIMPOSTRIB IS NULL BEGIN

               SET @V_BASECALCTO  = @V_BASECALCIT;
               SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
            END
            ELSE BEGIN
               /*Se o parametro de "Utiliza PMC" estiver marcado eu comparo o percentual de majorao com o valor maximo
               de venda e o maior entra na base de calculo. Se o parametro estiver desmarcado sempre sera utilizado o percentual de
               majorao */

               IF ISNULL(@V_IDPMCBASECAL, 'S') = 'S' BEGIN

                  IF @V_BASECALCIT > @V_BASEVLRMAX BEGIN
                     SET @V_BASECALCTO  = @V_BASECALCIT;
                     SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
                  END
                  ELSE BEGIN
                     SET @V_BASECALCTO  = @V_BASEVLRMAX;
                     SET @V_IMPOSTOIT   = (@V_BASEVLRMAX * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
                  END;
               END
               ELSE BEGIN
                  SET @V_BASECALCTO  = @V_BASECALCIT;
                  SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
               END;
            END;

            IF @V_CDIMPOSTRIB IS NULL BEGIN
               SET @V_IDTRIMPSTII = '';
            END
            ELSE BEGIN
               SET @V_IDTRIMPSTII = @V_TRATIMPST;
            END;

            IF (@V_IMPOSTOIT < 0) BEGIN
               SET @V_IMPOSTOIT = 0;
            END;

            IF (@V_ALIQUTMP = 0) AND (@V_IMPOSTOIT = 0) BEGIN
               SET @V_BASECALCTO = 0;
            END;


            IF @V_IDTRATIMPO = 'D' BEGIN
               SET @V_IMPOSTOTAL = - ROUND(@V_IMPOSTOIT,2);
            END
            ELSE BEGIN
               SET @V_IMPOSTOTAL = ROUND(@V_IMPOSTOIT,2);
            END;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAL+@V_NRLANCTONF;

            IF @V_NRMES = 1 BEGIN
               SELECT @V_COUNT = COUNT(*)
                FROM ITRELACITORCAOP
               WHERE NRANOORCAOP   = @P_NRANOORCAOP
                 AND CDFILIAL      = @P_CDFILIAL
                 AND NRSEQITEMORCA = @P_NRITLANCROP
                 AND NRSEQRELACORCAOP = @V_NRSEQRELACIT;

               IF @V_COUNT > 0 BEGIN
                  DELETE  FROM ITRELACITORCAOP
                   WHERE NRANOORCAOP   = @P_NRANOORCAOP
                     AND CDFILIAL      = @P_CDFILIAL
                     AND NRSEQITEMORCA = @P_NRITLANCROP
                     AND NRSEQRELACORCAOP = @V_NRSEQRELACIT;
               END;
               INSERT INTO  ITRELACITORCAOP
                   (NRANOORCAOP, CDFILIAL , NRSEQITEMORCA, NRSEQRELACORCAOP, CDITRELITORCAOP, VRRELITORCOPJAN )
               VALUES
                   (@P_NRANOORCAOP, @P_CDFILIAL, @P_NRITLANCROP, @V_NRSEQRELACIT, @V_CDIMPOTEMP, @V_IMPOSTOTAL );
            END
            ELSE BEGIN
               UPDATE ITRELACITORCAOP
                  SET VRRELITORCOPFEV = (CASE @V_NRMES WHEN  2 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPFEV,0) END),
                      VRRELITORCOPMAR = (CASE @V_NRMES WHEN  3 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPMAR,0) END),
                      VRRELITORCOPABR = (CASE @V_NRMES WHEN  4 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPABR,0) END),
                      VRRELITORCOPMAI = (CASE @V_NRMES WHEN  5 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPMAI,0) END),
                      VRRELITORCOPJUN = (CASE @V_NRMES WHEN  6 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPJUN,0) END),
                      VRRELITORCOPJUL = (CASE @V_NRMES WHEN  7 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPJUL,0) END),
                      VRRELITORCOPAGO = (CASE @V_NRMES WHEN  8 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPAGO,0) END),
                      VRRELITORCOPSET = (CASE @V_NRMES WHEN  9 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPSET,0) END),
                      VRRELITORCOPOUT = (CASE @V_NRMES WHEN 10 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPOUT,0) END),
                      VRRELITORCOPNOV = (CASE @V_NRMES WHEN 11 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPNOV,0) END),
                      VRRELITORCOPDEZ = (CASE @V_NRMES WHEN 12 THEN @V_IMPOSTOTAL ELSE ISNULL(VRRELITORCOPDEZ,0) END)
                WHERE NRANOORCAOP   = @P_NRANOORCAOP
                  AND CDFILIAL      = @P_CDFILIAL
                  AND NRSEQITEMORCA = @P_NRITLANCROP
                  AND CDITRELITORCAOP = @V_CDIMPOTEMP
                  AND NRSEQRELACORCAOP = @V_NRSEQRELACIT ;
            END;
            SET @V_NRMES  = @V_NRMES + 1;
         END; -- FIM LOOP MS
         FETCH NEXT FROM C_INCIDENCIA INTO @V_CDIMPOTEMP,   @V_CDFISCTEMP,   @V_IDTRATIMPTMP,
                                           @V_IDUTMUNIORIG, @V_IDCONSISTENT, @V_IDIMPORECUP,
                                           @V_IDTRATIMPO;

      END;  -- FIM INCIDENCIA
      CLOSE C_INCIDENCIA ;
      DEALLOCATE C_INCIDENCIA;

      DELETE INCITEMP
      WHERE NRINCITEMP = @P_CDFILIAL+@V_NRLANCTONF;

      FETCH NEXT FROM C_FATURA INTO @V_CDFILIAL, @V_CDSERVFILI, @V_CDARVPROD,  @V_CDPRODUTO, @V_VRORCAMENTOJAN, @V_VRORCAMENTOFEV,
                  @V_VRORCAMENTOMAR, @V_VRORCAMENTOABR, @V_VRORCAMENTOMAI, @V_VRORCAMENTOJUN, @V_VRORCAMENTOJUL, @V_VRORCAMENTOAGO,
                  @V_VRORCAMENTOSET, @V_VRORCAMENTOOUT, @V_VRORCAMENTONOV, @V_VRORCAMENTODEZ , @V_QTORCAMENTOJAN, @V_QTORCAMENTOFEV,
                  @V_QTORCAMENTOMAR, @V_QTORCAMENTOABR,  @V_QTORCAMENTOMAI,  @V_QTORCAMENTOJUN,  @V_QTORCAMENTOJUL, @V_QTORCAMENTOAGO,
                  @V_QTORCAMENTOSET, @V_QTORCAMENTOOUT,  @V_QTORCAMENTONOV,  @V_QTORCAMENTODEZ, @V_DTMESBASEITEM;

   END;

   CLOSE C_FATURA;
   DEALLOCATE C_FATURA;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTOORCA_RELGESDIRETA','5.30.xxx';
GO
